Getting Started with ListMenu Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the ListMenu module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.listmenu.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-list-menu id="listmenu"></smart-list-menu>

    Host container (id matches appendTo on Smart.ListMenu):

    <div id="listmenuContainer"></div>

  5. Initialize after the module loads: define a const listmenuOptions object, then either bind with Smart('#listmenu', ...) on the semantic tag or use new Smart.ListMenu({ ...listmenuOptions, appendTo: '#listmenuContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.listmenu.js';
    
    	const listmenuOptions = {checkboxes: true, checkable: true};
    
    	// Option A - semantic <smart-list-menu> with id="listmenu"
    	Smart('#listmenu', class {
    		get properties() {
    			return listmenuOptions;
    		}
    	});
    
    	// Option B - host div id="listmenuContainer"
    	// const listmenuInstance = new Smart.ListMenu({
    	// 	...listmenuOptions,
    	// 	appendTo: '#listmenuContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myListMenu = new Smart.ListMenu('#listmenu', listmenuOptions);
    	// document.body.appendChild(myListMenu);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.ListMenu('#listmenu', listmenuOptions) with appendChild, and document.createElement('smart-list-menu') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.ListMenu({ ...options, appendTo: '#...' }); new Smart.ListMenu('#listmenu', listmenuOptions) plus appendChild on the returned element; and document.createElement('smart-list-menu') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myListMenu = new Smart.ListMenu('#listmenu', listmenuOptions)):

	const listmenuOptions = {checkboxes: true, checkable: true};
	const myListMenu = new Smart.ListMenu('#listmenu', listmenuOptions);
	document.body.appendChild(myListMenu);
	

Create with document.createElement('smart-list-menu'), assign properties (same as any custom element), then append:

	const listmenuOptions = {checkboxes: true, checkable: true};
	const listmenu = document.createElement('smart-list-menu');
	Object.assign(listmenu, listmenuOptions);
	document.body.appendChild(listmenu);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.listmenu.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const listmenuOptions = {checkboxes: true, checkable: true};
		const listmenu = new Smart.ListMenu({
			...listmenuOptions,
			appendTo: '#listmenuContainer'
		});
	}
	

Appearance

The list menu structure contains smart-menu-item and smart-menu-items-group elements.

The following attributes are available for these custom elements.

  • label - the label to be displayed in the list menu
  • separator - if present, a visual separator (horizontal line) is added after the item
  • disabled - disables the selection of an item

The following attributes are only available for smart-menu-item.

  • value - a custom value that is not displayed, but is passed as an argument to the itemClick event (called when an item is chosen).
  • shortcut - a helper text/icon that can represent a keyboard shortcut that activates the item. The shortcut is not displayed for top-level items in horizontal and vertical modes.

Animated list menu could be achieved when animation class is added .

 <smart-list-menu class="animation"></smart-list-menu>

Demo

The list menu and its items can have checkbox or radio button selection. To allow this the user has to set element's checkboxes property to true and checkable for the particular items or group.

 <smart-list-menu checkboxes checkable></smart-list-menu>

Demo

Data Binding

To initialize a populated Smart.ListMenu custom element, insert the required inner structure consisting of the auxiliary custom elements smart-menu-item and smart-menu-items-group, e.g.:

<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.listmenu.js"></script>
</head>
<body>
 <smart-list-menu>
    <smart-menu-items-group>
        File
        <smart-menu-item shortcut="Ctrl+N">New</smart-menu-item>
        <smart-menu-item shortcut="Ctrl+0">Open</smart-menu-item>
        <smart-menu-items-group>
            Open Containing Folder
            <smart-menu-item>Explorer</smart-menu-item>
            <smart-menu-item>cmd</smart-menu-item>
        </smart-menu-items-group>
        <smart-menu-item shortcut="Ctrl+S" disabled>Save</smart-menu-item>
        <smart-menu-item shortcut="Ctrl+Alt+S" separator>Save As...</smart-menu-item>
        <smart-menu-item shortcut="Alt+F4">Exit</smart-menu-item>
    </smart-menu-items-group>
    <smart-menu-items-group>
        Help
        <smart-menu-item>About</smart-menu-item>
        <smart-menu-item>Help center</smart-menu-item>
        <smart-menu-item>Feedback</smart-menu-item>
    </smart-menu-items-group>
 </smart-list-menu>
</body>
</html>

Demo

Populating from UL :

<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.listmenu.js"></script>
</head>
<body>
 <smart-list-menu id="menu">
    <ul>
        <li><a href="#Home">Home</a></li>
        <li>
                Solutions
                    <li><a href="#Education">Education</a></li>
                    <li><a href="#Financial">Financial services</a></li>
                    <li>
                        Software Solutions
                        <ul>
                            <li><a href="#ConsumerPhoto">Consumer photo and video</a></li>
                            <li><a href="#Mobile">Mobile</a></li>
                            <li><a href="#RIA">Rich Internet applications</a></li>
                        </ul>
                    </li>
                <li><a href="#">All industries and solutions</a></li>
                </ul>
        </li>
        <li>
                Products
                <ul>
                    <li><a href="#PCProducts">PC products</a></li>
                    <li><a href="#MobileProducts">Mobile products</a></li>
                    <li><a href="#AllProducts">All products</a></li>
                </ul>
        </li>
        <li>
                Support
                <ul>
                    <li><a href="#SupportHome">Support home</a></li>
                    <li><a href="#CustomerService">Customer Service</a></li>
                    <li><a href="#KB">Knowledge base</a></li>
                    <li><a href="#Books">Books</a></li>
                </ul>
        </li>
    </ul>
 </smart-list-menu>
</body>
</html>

Demo

Populating from dataSource.

<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.listmenu.js"></script>

 <script>
 window.onload = function () {
     document.querySelector('smart-list-menu').dataSource = [
                {
                    label: 'File',
                    items: [
                        {
                            label: 'New',
                            shortcut: 'Ctrl+N'
                        },
                        {
                            label: 'Open',
                            shortcut: 'Ctrl+0'
                        },
                        {
                            label: 'Open Containing Folder',
                            items: [
                                {
                                    label: 'Explorer'
                                },
                                {
                                    label: 'cmd'
                                }
                            ]
                        },
                        {
                            label: 'Save',
                            shortcut: 'Ctrl+S',
                            disabled: true,
                            separator: true
                        },
                        {
                            label: 'Exit',
                            shortcut: 'Alt+F4'
                        }
                    ]
                }
            ];
     }
 </script>
</head>
<body>
    <smart-list-menu></smart-list-menu>
</body>
</html>

Demo

Behavior

Smart.ListMenu could be minimized/maximized. The element has minimizeWidth property. It determines the minimum width of the ListMenu at which it will switch from normal to minimized mode. If set to null, the ListMenu does not minimize automatically.

<!DOCTYPE html>
<html lang="en">
<head>
  <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.listmenu.js"></script>

 <script>
 window.onload = function () {
     document.querySelector('smart-list-menu').minimizeWidth = 1000;
 }
 </script>
</head>
<body>
    <smart-list-menu></smart-list-menu>
</body>
</html>

Demo

User can switch between few drop down positions. The value of dropDownPosition could be:

  • top-left
  • top-right
  • bottom-left
  • bottom-right
  • auto
                    <smart-menu minimize-width="1000" drop-down-position="top-right"></smart-menu>

Demo

The element supports filtering and grouping. The following filter modes are allowed:

  • contains
  • containsIgnoreCase
  • doesNotContain
  • doesNotContainIgnoreCase
  • equals
  • equalsIgnoreCase
  • startsWith
  • startsWithIgnoreCase
  • endsWith
  • endsWithIgnoreCase
<smart-list-menu filterable filter-mode="startsWith" filter-mode grouped></smart-list-menu>

Demo

Manipulating the content

The element offers the following methods:

  • addItem - adds new item to the list menu.
     <script>
         window.onload = function () {
             var listMenu = document.querySelector('smart-list-menu');
             listMenu.addItem(document.createElement('smart-menu-item'), '0');
         }
     </script>
    
  • back - navigates to the previous page (smart-menu-items-group).
     <script>
         window.onload = function () {
             var listMenu = document.querySelector('smart-list-menu');
             listMenu.back();
         }
     </script>
    
  • changePage - navigates to a particular page (smart-menu-items-group).
     <script>
         window.onload = function () {
             var listMenu = document.querySelector('smart-list-menu');
             listMenu.changePage(0.0);
         }
     </script>
    
  • checkItem - checks an item.
     <script>
         window.onload = function () {
             var listMenu = document.querySelector('smart-list-menu');
             listMenu.checkItem(0.0);
         }
     </script>
    
  • getItem - gets an item by its id or numeric path.
     <script>
         window.onload = function () {
             var listMenu = document.querySelector('smart-list-menu');
             listMenu.getItem(0.0);
         }
     </script>
    
  • maximize - maximizes the list menu.
     <script>
         window.onload = function () {
             var listMenu = document.querySelector('smart-list-menu');
             listMenu.maximize();
         }
     </script>
    
  • minimize - minimizes the list menu.
     <script>
         window.onload = function () {
             var listMenu = document.querySelector('smart-list-menu');
             listMenu.minimize();
         }
     </script>
    
  • removeItem - removes an item.
     <script>
         window.onload = function () {
             var listMenu = document.querySelector('smart-list-menu');
             listMenu.removeItem(0.0);
         }
     </script>
    
  • setFocusable - sets whether the element can be focused or not.
     <script>
         window.onload = function () {
             var listMenu = document.querySelector('smart-list-menu');
             listMenu.setFocusable(false);
         }
     </script>
    
  • uncheckItem - unchecks an item. The id or the path to the item is passed in as the method argument.
     <script>
         window.onload = function () {
             var listMenu = document.querySelector('smart-list-menu');
             listMenu.uncheckItem('0.0');
         }
     </script>
    

Keyboard Support

Key Action
Tab The list menu receives focus by tabbing into it.
Arrow Up / Arrow Down Navigates to the previous/next item in the current view.
Arrow Left / Arrow Right Navigates to the previous/next view.
Home Navigates to the "back" button or the first enabled item (for the top-level view).
End Navigates to the last enabled item in the current view.
Enter Selects an item/opens an items group (new view). If the list menu is minimized and the minimized pop-up is closed, opens the pop-up.
Escape Navigates to the previous view. If the top-level view is reached and the list menu is minimized, closes the minimized pop-up.
Space Toggles an item's checked state.

Append to the DOM:

const container = document.getElementById('listmenu-container');
container.appendChild(listmenu);
	

Remove from the DOM:

listmenu.remove();
	

Set a property:

listmenu.disabled = true;
listmenu.theme = 'dark';
	

Get a property value:

const isDisabled = listmenu.disabled;
const currentTheme = listmenu.theme;
	

Invoke a method:

listmenu.refresh();
listmenu.focus();
	

Add event listener:

listmenu.addEventListener('itemClick', (event) => {
    console.log('itemClick triggered:', event.detail.item);
});
	

Remove event listener:

const handleListMenuEvent = (event) => {
    console.log('itemClick triggered:', event.detail.item);
};

listmenu.addEventListener('itemClick', handleListMenuEvent);
listmenu.removeEventListener('itemClick', handleListMenuEvent);
	

Accessibility

The ListMenu component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React ListMenu Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/listmenu/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { ListMenu, MenuItem, MenuItemsGroup } from 'smart-webcomponents-react/listmenu';

const App = () => {
    // Any logic that was in init() or componentDidMount() can go here, e.g. in useEffect.
    // useEffect(() => {
    //     // componentDidMount equivalent
    // }, []);

    return (
        <div>
            <ListMenu id="listMenu" className="animation">
                <MenuItemsGroup>File
                    <MenuItem shortcut="Ctrl+N">New</MenuItem>
                    <MenuItem shortcut="Ctrl+0">Open</MenuItem>
                    <MenuItemsGroup>Open Containing Folder
                        <MenuItem>Explorer</MenuItem>
                        <MenuItem>cmd</MenuItem>
                    </MenuItemsGroup>
                    <MenuItem shortcut="Ctrl+S" disabled>Save</MenuItem>
                    <MenuItem shortcut="Ctrl+Alt+S" separator>Save As...</MenuItem>
                    <MenuItem shortcut="Alt+F4">Exit</MenuItem>
                </MenuItemsGroup>
                <MenuItemsGroup>Edit
                    <MenuItem shortcut="Ctrl+Z">Undo</MenuItem>
                    <MenuItem shortcut="Ctrl+Y" separator>Redo</MenuItem>
                    <MenuItem shortcut="Ctrl+X">Cut</MenuItem>
                    <MenuItem shortcut="Ctrl+C">Copy</MenuItem>
                    <MenuItem shortcut="Ctrl+V" disabled>Paste</MenuItem>
                </MenuItemsGroup>
                <MenuItemsGroup>Encoding
                    <MenuItem>Encode in ANSI</MenuItem>
                    <MenuItem>Encode in UTF-8</MenuItem>
                    <MenuItem>Encode in UTF-8-BOM</MenuItem>
                    <MenuItem>Encode in UTCS-2 BE BOM</MenuItem>
                    <MenuItem>Encode in UTCS-2 LE BOM</MenuItem>
                    <MenuItemsGroup separator>Character sets
                        <MenuItemsGroup>Cyrillic
                            <MenuItem>ISO 8859-5</MenuItem>
                            <MenuItem>KOI8-R</MenuItem>
                            <MenuItem>KOI8-U</MenuItem>
                            <MenuItem>Windows-1251</MenuItem>
                        </MenuItemsGroup>
                        <MenuItemsGroup>Chinese
                            <MenuItem>Big5 (Traditional)</MenuItem>
                            <MenuItem>GB2312 (Simplified)</MenuItem>
                        </MenuItemsGroup>
                        <MenuItemsGroup>Western European
                            <MenuItem>ISO 8859-1</MenuItem>
                            <MenuItem>ISO 8859-15</MenuItem>
                            <MenuItem>OEM 850</MenuItem>
                            <MenuItem>Windows-1252</MenuItem>
                        </MenuItemsGroup>
                    </MenuItemsGroup>
                    <MenuItem>Convert to ANSI</MenuItem>
                    <MenuItem>Convert to UTF-8</MenuItem>
                    <MenuItem>Convert to UTF-8-BOM</MenuItem>
                    <MenuItem>Convert to UTCS-2 BE BOM</MenuItem>
                    <MenuItem>Convert to UTCS-2 LE BOM</MenuItem>
                </MenuItemsGroup>
            </ListMenu>
        </div>
    );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { ListMenu, ListMenuProps } from 'smart-webcomponents-react/listmenu';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The ListMenu component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular ListMenu - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/listmenu/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import ListMenuModule from smart-webcomponents-angular/listmenu: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { ListMenuModule } from 'smart-webcomponents-angular/listmenu';

4 Root component (standalone)

Add ListMenuModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { ListMenuComponent } from 'smart-webcomponents-angular/listmenu';

import { ListMenuModule } from 'smart-webcomponents-angular/listmenu';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ ListMenuModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('listmenu', { read: ListMenuComponent, static: false }) listmenu!: ListMenuComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-list-menu as needed:

 <smart-list-menu #listmenu id="listMenu" class="animation">
    <smart-menu-items-group>
        File
        <smart-menu-item [shortcut]="'Ctrl+N'">New</smart-menu-item>
        <smart-menu-item [shortcut]="'Ctrl+0'">Open</smart-menu-item>
        <smart-menu-items-group>
            Open Containing Folder
            <smart-menu-item>Explorer</smart-menu-item>
            <smart-menu-item>cmd</smart-menu-item>
        </smart-menu-items-group>
        <smart-menu-item [shortcut]="'Ctrl+S'" [disabled]="true">Save</smart-menu-item>
        <smart-menu-item [shortcut]="'Ctrl+Alt+S'" [separator]="true">Save As...</smart-menu-item>
        <smart-menu-item [shortcut]="'Alt+F4'">Exit</smart-menu-item>
    </smart-menu-items-group>
    <smart-menu-items-group>
        Edit
        <smart-menu-item [shortcut]="'Ctrl+Z'">Undo</smart-menu-item>
        <smart-menu-item [shortcut]="'Ctrl+Y'" [separator]="true">Redo</smart-menu-item>
        <smart-menu-item [shortcut]="'Ctrl+X'">Cut</smart-menu-item>
        <smart-menu-item [shortcut]="'Ctrl+C'">Copy</smart-menu-item>
        <smart-menu-item [shortcut]="'Ctrl+V'" [disabled]="true">Paste</smart-menu-item>
    </smart-menu-items-group>
    <smart-menu-items-group>
        Encoding
        <smart-menu-item>Encode in ANSI</smart-menu-item>
        <smart-menu-item>Encode in UTF-8</smart-menu-item>
        <smart-menu-item>Encode in UTF-8-BOM</smart-menu-item>
        <smart-menu-item>Encode in UTCS-2 BE BOM</smart-menu-item>
        <smart-menu-item>Encode in UTCS-2 LE BOM</smart-menu-item>
        <smart-menu-items-group [separator]="true">
            Character sets
            <smart-menu-items-group>
                Cyrillic
                <smart-menu-item>ISO 8859-5</smart-menu-item>
                <smart-menu-item>KOI8-R</smart-menu-item>
                <smart-menu-item>KOI8-U</smart-menu-item>
                <smart-menu-item>Windows-1251</smart-menu-item>
            </smart-menu-items-group>
            <smart-menu-items-group>
                Chinese
                <smart-menu-item>Big5 (Traditional)</smart-menu-item>
                <smart-menu-item>GB2312 (Simplified)</smart-menu-item>
            </smart-menu-items-group>
            <smart-menu-items-group>
                Western European
                <smart-menu-item>ISO 8859-1</smart-menu-item>
                <smart-menu-item>ISO 8859-15</smart-menu-item>
                <smart-menu-item>OEM 850</smart-menu-item>
                <smart-menu-item>Windows-1252</smart-menu-item>
            </smart-menu-items-group>
        </smart-menu-items-group>
        <smart-menu-item>Convert to ANSI</smart-menu-item>
        <smart-menu-item>Convert to UTF-8</smart-menu-item>
        <smart-menu-item>Convert to UTF-8-BOM</smart-menu-item>
        <smart-menu-item>Convert to UTCS-2 BE BOM</smart-menu-item>
        <smart-menu-item>Convert to UTCS-2 LE BOM</smart-menu-item>
    </smart-menu-items-group>
</smart-list-menu>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put ListMenuModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put ListMenuModule from smart-webcomponents-angular/listmenu on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ListMenuModule } from 'smart-webcomponents-angular/listmenu';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, ListMenuModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The ListMenu component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.